-- BLpopper v1.2c

local frame = CreateFrame("Frame")
frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")

local Drums = {
	[146555] = true, 	-- Drums of Rage (MoP)
	[178207] = true, 	-- Drums of Fury (WoD)
	[230935] = true, 	-- Drums of the Mountain (Legion)
	[256740] = true, 	-- Drums of the Maelstrom (BfA)
}

local Bloodlust = {
	[2825] = true, 		-- Bloodlust (Horde Shaman)
	[32182] = true, 	-- Heroism (Alliance Shaman)
	[80353] = true, 	-- Time Warp (Mage)
	[272678] = true, 	-- Primal Rage (Hunter, cast by command pet)
}

local PetBL = {
	[264667] = true, 	-- Primal Rage (Hunter, cast from pet spellbook)
}

local scanTool = CreateFrame( "GameTooltip", "ScanTooltip", nil, "GameTooltipTemplate" )
scanTool:SetOwner( WorldFrame, "ANCHOR_NONE" )
local scanText = _G["ScanTooltipTextLeft2"]

function getPetOwner(sourceName)
	scanTool:ClearLines()
	scanTool:SetUnit(sourceName)
	local ownerText = scanText:GetText()
	if not ownerText then return sourceName end
	local owner, _ = string.split("-'",ownerText)
	return owner
end

frame:SetScript("OnEvent", function(self, event, ...)
	local _, event, _, _, sourceName, _, _, _, _, _, _, spellID, _ = CombatLogGetCurrentEventInfo()
		if event == "SPELL_CAST_SUCCESS" and GetNumGroupMembers() > 0 and (Drums[spellID] or Bloodlust[spellID] or PetBL[spellID]) and (UnitPlayerOrPetInParty(sourceName) or UnitPlayerOrPetInRaid(sourceName)) then
			local chatType = "PARTY"
			local isInstance, instanceType = IsInInstance()
			if isInstance and IsInGroup(LE_PARTY_CATEGORY_INSTANCE) or instanceType == "pvp" then
				chatType = "INSTANCE_CHAT"
			elseif IsInRaid() then
				chatType = "RAID"
			end

			if Drums[spellID] then
				SendChatMessage("BLpopper: " .. UnitName(sourceName) .. " " .. GetSpellLink(spellID) .. " (25% haste)",chatType)
			elseif Bloodlust[spellID] then
				SendChatMessage("BLpopper: " .. UnitName(sourceName) .. " " .. GetSpellLink(spellID) .. " (30% haste)",chatType)
			elseif PetBL[spellID] then
				SendChatMessage("BLpopper: " .. getPetOwner(sourceName) .. " " .. GetSpellLink(spellID) .. " (30% haste)",chatType)
			end
		end
	end
)
